package drills.drill07.exercise2

import org.apache.activemq.ActiveMQConnectionFactory
import javax.jms.Queue
import javax.jms.QueueConnectionFactory
import javax.jms.Session
import javax.jms.TextMessage

fun main() {
    val url = "tcp://localhost:61616"
    val factory: QueueConnectionFactory = ActiveMQConnectionFactory(url)

    val connection = factory.createQueueConnection()
    connection.start()

    val session = connection.createQueueSession(
        false,
        Session.AUTO_ACKNOWLEDGE
    )

    val queue = session.createQueue("requestor")
    val receiver = session.createReceiver(queue)

    val msg = receiver.receive() as TextMessage
    println(msg.text)

    val replyQueue = msg.jmsReplyTo as Queue
    val sender = session.createSender(replyQueue)
    val replyMsg = session.createTextMessage("Echo ${msg.text}")

    sender.send(replyMsg)

    session.close()
    connection.close()
}
