package drills.drill08.exercise2

import kotlin.time.ExperimentalTime
import kotlin.time.measureTime

class Worker(private val finder: Finder) : Thread() {
    @ExperimentalTime
    override fun run() {
        val elapsed = measureTime {
            repeat(REQUEST_NUMBER) {
                finder.find("test-$it")
            }
        }

        println("Thread $this elapsed: $elapsed")
        println("Thread $this mean time for request: ${elapsed / REQUEST_NUMBER}")
    }

    companion object {
        const val REQUEST_NUMBER = 60
    }
}
