package drills.drill08.exercise3

import drills.drill08.exercise2.Finder
import util.jms.replicatedobject.ReplicatedObjectFactory
import util.rmi.Server
import java.rmi.server.UnicastRemoteObject

fun main() {
    Server {
        val finder = FinderProxy()
        Server.bind(finder, "finder")
    }.start()
}

class FinderProxy : Finder, UnicastRemoteObject() {
    private val finder = ReplicatedObjectFactory(Finder::class.java)
        .create("finder")
    override fun find(str: String): Boolean {
        return finder.find(str)
    }
}
